// TIMER TINY85 CTC. DEFRAN24
// ATTinyCore:avr:attinyx5   Poner el Tiny85 a 1 MHz como en real.

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
int MON=1;              // MON monitor D3.
int RED=0;              // LED RED 50Hz
int RELE=3;             // RELE D4.
int pulsa=A1;           // Pulsador pulsa D1.
int SelTmp=A2;          // MONResistiva Valor tiempo
int count;
int conto;
int ckv=0;              // Buscar Pulso.        
int ckpre=0;            // Buscar Pulso. AQUI SE DEFINE EL VALOR PARA MODO TEST.     
long conta=0;           // Contador del tiempo total. Valor por defecto (Tiempo de test en ms.).
int onda=0;             // Dutty onda
int SwV=0;              // Valor switch leido.
int lampv=0;            // Lampara. 
long tmax=0;            // Tiempo Maximo.
int pulsav=0;           // Pulsador puldado.
long pul;

void setup()
{
  pinMode(MON, OUTPUT);       // LED MONITOR
  pinMode(RELE, OUTPUT); 
  delay(20);                  // por el condensador 22ms
  START: 
  if(analogRead(pulsa)>500) goto START;  // Arranque con pulsador
  cli();                  // Disable global interrupts before initialization
  DDRB |= (1<<PINB0);     // initialize the PortB Pin0 to output; PINB0 RELOJ 50HZ
  TCCR0A  = (1<<WGM01);   // initialize the timer0. Put timer0 in CTC mode and clear other bits
  TCCR0B  = (B00000101);  // Timer0 prescaling 1000 and clearing other bits
  TIMSK  |= (1<<OCIE0A);  // enable timer1 compare interrupt
  OCR0A = 9;             // set the timer0 count. 255 cycles before to ISR. 50HZ: 155/80 in real.
  PORTB |= (1<<PINB0);    // Set PortB Pin1 high to turn on LED
  sei();                  // initialize global interrupts before beginning loop
  SwV=analogRead(SelTmp);                  // Lectura Pin analogico (0 a 1023).
  if ((SwV>480)&(SwV<530)) conta=1000;     // 20s  511   OFF  2.5V  (TEST)
  if (SwV>750)             conta=720000;   // 4h   767   DCB  3.7V
  if ((SwV>650)&(SwV<700)) conta=540000;   // 3h   681   DC   3.3V
  if ((SwV>240)&(SwV<270)) conta=360000;   // 2h   255   ABC  1.2V
  if ((SwV>310)&(SwV<360)) conta=30000;    // 10m  341   AB   1.6V conta=180000;
  tmax=conta;                              // Tiempo calculado maximo (Si valor=2.5V: MODO TEST). 
}

void loop()
{
  do
  {
    pulsav=analogRead(pulsa); 
    digitalWrite(RELE, HIGH);             // RELE ON, Lo antes posible___
    digitalWrite(MON, HIGH);  reta();   // Inicia con MON encendido.
    digitalWrite(MON, LOW);  reta();   // Inicia con MON encendido.
  } 
  while (pulsav<300);
  do
  {                                                 //___TEMPORIZA___
    ckv=conto; 
    digitalWrite(RED, ckv);                         // Reloj
    if (ckv!=ckpre){if(ckv==HIGH)conta--; onda++;}  // Pulsos TIEMPORIZACION.
    ckpre=ckv;    
    lampv=(conta*98)/tmax;                          // *** Monitor tiempo__. (VALOR VISUAL).98
    if (onda<=lampv) digitalWrite(MON, HIGH);       // Anchura pulso MON.
    else digitalWrite(MON, LOW);
    if (onda==100) onda=0;                          // *** (50 PARA SEGUNDOS OK). 100 EN REAL
    SwV=analogRead(SelTmp);
    do
    {                                               // ___TIEMPO PARADA FORZADA_____
      pulsav=analogRead(pulsa);                     // Lee Pulsador.
      if (pulsav<300)
      {
        digitalWrite(RELE, LOW);
        digitalWrite(MON, LOW);
        STOP:
        goto STOP;
      }
    }
    while (pulsav<300); 
  }
  while (conta!=0);         // Salida de la Temporizacion.
  digitalWrite(MON, LOW);   // MON ON para visualizar Tension de apagado.
  digitalWrite(RELE, LOW);  // RELE OFF.
  FIN:
  goto FIN;
}

ISR(TIM0_COMPA_vect) 
{
  if (!count++) {PORTB ^= (1<<PINB0);}  // toggle the PortB pin0 to HIGH or LOW
  conto={count & 1};                    // PAR, IMPAR. (50 HZ)
}

void reta()
{
    pul=0;
    while (pul<900000000) pul++ ;
}
